$(document).ready(function() {

  console.log("constructor_1");

  // $('#calendar').fullCalendar({
  //   header: {
  //     left: 'prev,next today',
  //     center: 'title',
  //     right: 'month,agendaWeek,agendaDay,listWeek'
  //   },
  //   defaultDate: Date(),
  //   navLinks: true, // can click day/week names to navigate views
  //   weekNumbers: true,
  //   weekNumbersWithinDays: true,
  //   weekNumberCalculation: 'ISO',
  //   editable: true,
  //   allDay: true,
  //   events:[ {
  //   title: 'Default Event',
  //       start: '2018-08-07',
  //       end: '2018-08-10'
  //   }],
  //   eventLimit: true, // allow "more" link when too many events
  //   eventDrop: function(event, delta, revertFunc) {
  //     $('#start_date').val(event.start.format());
  //   }
  // });

  var initialLocaleCode = 'en';
  var now = new Date().setMinutes(0);

  $('.datetimepick').datetimepicker({
    format: 'Y-m-d H:i',
  });

  $('.datepick').datetimepicker({
    timepicker: false,
    format: 'Y-m-d',
  });
  
  $('.datepick').datetimepicker({
    format:'Y-m-d',
  });

  $('#fullcalendar_scheduler').fullCalendar({
    schedulerLicenseKey: 'CC-Attribution-NonCommercial-NoDerivatives',
    now: now,
    editable: true, // enable draggable events
    aspectRatio: 1.8, // default: 1.35
    scrollTime: '00:00', // undo default 6am scrollTime
    header: {
      left: 'promptCourse,promptTrainer,promptRoom today prev,next',
      center: 'title',
      right: 'zoomIn,timeline1Day,timeline2Days,timeline3Days,timeline4Days,timeline5Days,timeline1Week,timeline2Weeks,timeline1Month,timeline3Months,timeline6Months,timeline1Year,zoomOut'
    },
    customButtons: {
      zoomIn: {
        text: '<',
      },
      zoomOut: {
        text: '>',
      },
      promptCourse: {
        text: '+Course',
        click: function() {
          var title = prompt('Course name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptTrainer: {
        text: '+Trainer',
        click: function() {
          var title = prompt('Trainer name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptRoom: {
        text: '+Room',
        click: function() {
          var title = prompt('Room name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      }
    },
    //defaultView: 'timeline3Days',
    defaultView: 'timeline1Day',
    views: {
      timeline1Day: {
        type: 'timeline',
        duration: { days: 1 },
      },
      timeline2Days: {
        type: 'timeline',
        duration: { days: 2 }
      },
      timeline3Days: {
        type: 'timeline',
        duration: { days: 3 }
      },
      timeline4Days: {
        type: 'timeline',
        duration: { days: 4 }
      },
      timeline5Days: {
        type: 'timeline',
        duration: { days: 5 }
      },
      timeline1Week: {
        type: 'timeline',
        duration: { weeks: 1 },
      },
      timeline2Weeks: {
        type: 'timeline',
        duration: { weeks: 2 },
      },
      timeline1Month: {
        type: 'timeline',
        duration: { month: 1 },
      },
      timeline3Months: {
        type: 'timeline',
        duration: { month: 3 },
      },
      timeline6Months: {
        type: 'timeline',
        duration: { month: 6 },
      },
      timeline1Year: {
        type: 'timeline',
        duration: { year: 1 },
      },
    },

    resourceAreaWidth: '20%',
    resourceGroupField: 'resourceType',

    // If refetchResourcesOnNavigate is set to true, the network request will
    // be made with additional parameters: the start/end date of the newly
    // visible window of time, as well as the calendar’s timezone
    //
    // example request: /resource_planner/resources.json?start=2017-12-01&end=2017-01-12&timezone=UTC
    refetchResourcesOnNavigate: true,
    resources: {
     url: '/resource_planner/resources.json',
     type: 'GET',
    },

    eventSources: [
      {
        // Active events
        url: '/resource_planner/resource_events.json',
        type: 'GET',
        error: function() {
          alert('there was an error while fetching active events!');
        },
        //color: 'yellow',
        //textColor: 'black',
      },
      {
        // Non-availability / Restrictions
        url: '/resource_planner/resource_restrictions.json',
        type: 'GET',
        error: function() {
          alert('there was an error while fetching event restrictions!');
        },
        color: 'grey',
        textColor: 'black',
      },
    ],

    // Callbacks
    resourceRender: function(resourceObj, labelTds, bodyTds) {

      labelTds.on('click', function() {
        //var resource_id = labelTds.parent().attr('data-resource-id');
        var unselected_background_color = 'rgba(0, 0, 0, 0)';
        var selected = (labelTds.css('background-color') != unselected_background_color);

        if(selected) {
          labelTds.css('background-color', unselected_background_color);
          bodyTds.css('background-color', unselected_background_color);
        } else {
          labelTds.css('background-color', 'blue');
          bodyTds.css('background-color', 'cyan');
        }
      });

      // labelTds.css('background', 'blue');
      // bodyTds.css('background', 'yellow');
      // resource_id = labelTds.parent().attr("data-resource-id");
      // labelTds.eq(0).find('.fc-cell-content')
      //   .append(
      //     $('<strong>('+resource_id+')</strong>')
      //     //$('<strong>(?)</strong>')
      //     //.popover({
      //     //  title: resourceObj.title,
      //     //  content: 'test!',
      //     //  trigger: 'hover',
      //     //  placement: 'bottom',
      //     //  container: 'body'
      //     //})
      //   );
    },

    viewRender: function(view, element) {
    },

    eventAfterAllRender: function (view) {
      renderScrollBar();
      renderHighlighterBar();
    },

    eventDrop: function(event, delta, revertFunc) {
      if (!confirm(event.title + " was changed to " + event.start.format() + "\nAre you sure about this change?")) {
        revertFunc();
      }
    },

  }); // end fullcalendar() initialisation

  // build the locale selector's options
  $.each($.fullCalendar.locales, function(localeCode) {
    $('#locale-selector').append(
      $('<option/>')
        .attr('value', localeCode)
        .prop('selected', localeCode == initialLocaleCode)
        .text(localeCode)
    );
  });
  setLocaleCode(initialLocaleCode);

  // Initialise the doubleScroll
  renderScrollBar();

  // Initialise the highlighter bar
  renderHighlighterBar();


  //

  /********************************************* Locale Handlers *********************************************/
  // when the selected option changes, dynamically change the calendar option
  $('#locale-selector').on('change', function() {
    if (this.value) {
      setLocaleCode(this.value);
      renderHighlighterBar();
    }
  });
  /*_________________________________________________________________________________________________________*/


  /******************************************** EVENT HANDLERS ***********************************************/
  /******************************************* Timezone Handlers *********************************************/
  $('#resource_planner_event_dtstart_timezone').on('change', function() {
    renderHighlighterBar('timezone');
  
    $('#fullcalendar_scheduler').fullCalendar('changeView', 'timeline', {
      start: $.trim($("#start_date").val()),
      end: $.trim($("#end_date").val())
    });
    
    //$('#fullcalendar_scheduler').fullCalendar('option', 'visibleRange', {
    //  start: $.trim($("#start_date").val()),
    //  end: $.trim($("#end_date").val())
    //});

  });

  //a = $("#resource_planner_event_dtstart_timezone :selected").text()

  $('#resource_planner_event_dtstart_timezone').on('input', function() {
    renderHighlighterBar('timezone');
  });


/*************************************** Start/End Date Handlrers  *******************************************/
  $('.date-field').on('change', function() {
    renderHighlighterBar('date');
    updateTimelineDuration();
  });

  $('.date-field').on('input', function() {
    renderHighlighterBar('date');
    updateTimelineDuration();
  });


/************************************ Change/Input Duration Handlers *****************************************/
  /* These two listeners should be kept in sync */
  $('#duration').on('change', function() {
    renderEndDateField();
    renderHighlighterBar('duration');
  });

  $('#duration').on('input', function() {
    renderEndDateField();
    renderHighlighterBar('duration');
  });


/************************************** Duration Minutes/Hours Handlers **************************************/
  /* These two listeners should be kept in sync */
  $('#hourSelect').on('change', function() {
    renderDurationField();
  });


/******************************************* Reccuring Eevents Handlers **************************************/
/*************************************************** daily ***************************************************/
/**** reccurence_pattern ****/

$('input[name="resource_planner_event_count"]').on('input', function() {
  var howOften;                   // How often should an event occur ? every 'n' days or every '1' day ?
  const EVERY_DAY = 1;            // constant => every day...
  switch( $(this).val() ) {
    case 'every_n_days':               
      $("#resource_planner_event_count").val("1");                              // every 'n' days option selected
      howOften = 1;
      reccurences('every_n_days', howOften);
      break;
    case 'every_weekday':
      $("#resource_planner_event_count").val("");                       // every weekday option selected
      howOften = EVERY_DAY;                                             // make sure the "every [n] days" field is empty
      reccurences('every_weekday', howOften);
      break;
    }
});

$('input[name="resource_planner_event[count]"]').on('input', function() {
  howOften = $(this).val();                                                                 // read how often should an event occur...
  document.getElementById("resource_planner_event_count_every_n_days").checked = true;      // make sure the "every [n] days" radio button is checked
  reccurences('every_n_days', howOften);
});

/***********************************************************************************************************/
/**** range_of_reccurence ****/
$('input[name*="resource_planner_event_until"]').on('input', function() {
  switch( $(this).val() ) {
    case 'no_end_date':                                        // no end dtae option selected
      $("#resource_planner_event_until_count").val("");        // make sure the "every [n] days" field is empty
      $("#repeat_until").val("");                              // make sure the "repeat until" field is empty
      //cleanRepeatUntilFields();
      reccurences('no_end_date');
      break;
    case 'create_n_events':                                   // create 'n' events radio button selected
      $("#resource_planner_event_until_count").val("1");      // make sure the "every [n] days" field is empty
      $("#repeat_until").val("");                             // make sure the "repeat until" field is empty
      //cleanRepeatUntilFields();
      reccurences('create_n_events');
      break;
    case 'repeat_until':                                      // repeat untill radio button selected
      $("#resource_planner_event_until_count").val("");       // make sure the "every [n] days" field is empty
      //cleanRepeatUntilFields();
      reccurences('repeat_until');
      break;
    default:
      //cleanRepeatUntilFields();
      document.getElementById("resource_planner_event_until_create_n_events").checked = true;   // the 'n' number of events was typed
      $("#repeat_until").val("");                             // make sure the "repeat until" field is empty
      reccurences('create_n_events');
  }

});

// repeat until date & time selection
$('#repeat_until').on('change', function() {
  $("#resource_planner_event_until_count").val("");
  document.getElementById("resource_planner_event_until_repeat_until").checked = true;

  $('#fullcalendar_scheduler').fullCalendar('changeView', 'timeline', {
    start: $.trim($("#start_date").val()),
    end: $.trim($("#end_date").val())
  });

  //renderHighlighterBar('date');
});


/*___________________________________________________________________________________________________________*/
/************************************************** Weekly ***************************************************/
var checkbox = document.querySelector("input[name*='resource_planner_event_day[sunday]']");

checkbox.addEventListener( 'change', function() {
//
//$('.form-control date-field datepick').click(function() {
//a = document.getElementsByClassName('first_button');
//a.change(function() {

//$("input[type='checkbox']").click(function(){
//$('input:checkbox').change(function(){
//$('input[type=checkbox]').change(function(){
//$('input[name*="resource_planner_event_day"]').change(function() {
  //$('input[name="resource_planner_event_day[sunday]"]').change(function() {
//$('input[name*="resource_planner_event_day"]').on('change', function() {
//checkbox.addEventListener( 'change', function() {
  if($(this).is(':checked')){
    console.log("day of the week clicked");
  }
//$('#my_checkbox').click(function(){
//$('#resource_planner_event_rrule').on('change', function() {
//  renderHighlighterBar('Weekly');
});

/*___________________________________________________________________________________________________________*/
/************************************************** Monthly **************************************************/
$('#resource_planner_event_rrule').on('change', function() {
  renderHighlighterBar('Monthly');
});

/*___________________________________________________________________________________________________________*/
/************************************************* Freeform **************************************************/
$('#resource_planner_event_rrule').on('change', function() {
  renderHighlighterBar('Freeform');
});

/*___________________________________________________________________________________________________________*/

  // Submit button
  $('input[type=submit]').on('click', function() {

    var resource_list = '';

    $('.fc-resource-area [data-resource-id]').each(function() {
      var resource_id = $(this).attr('data-resource-id');
      var unselected_background_color = 'rgba(0, 0, 0, 0)';
      var selected = ($(this).find('.fc-widget-content').css('background-color') != unselected_background_color);

      if(selected) {
        resource_list += resource_id + "\n";
      }
    });

    alert(
      "Event will be created:\n" +
      "Start    :" + $.trim($("#start_date").val()) + "\n" +
      "End      :" + $.trim($("#end_date").val()) + "\n" +
      "Resources:\n" +
      resource_list
    );

    // //Passing mdate and phone variables to rails controller(book_date & phone)
    // window.open("localhost:3000//controller/create?mdate="+mdate+"&phone="+phone,"_self")
    //
    // -- OR --
    //
    // /* Send the data using post and put the results in a div */
    // $.ajax({
    //   url: "/BookCreate/?mdate="+mdate+"&phone="+phone,
    //   type: "post",
    //   data: values,
    //   success: function(){
    //     alert('Saved Successfully');
    //   },
    //   error:function(){
    //     alert('Error');
    //   }
    // });

  });

  // Initialize Date Time range_of_reccurence fields
  $("#resource_planner_event_until_1i").val("");
  $("#resource_planner_event_until_2i").val("");
  $("#resource_planner_event_until_3i").val("");
  $("#resource_planner_event_until_time_4i").val("");
  $("#resource_planner_event_until_time_5i").val("");

});


//
// Common/Helper functions
//

function setLocaleCode(localeCode) {
  $.datetimepicker.setLocale(localeCode);
  $('#fullcalendar_scheduler').fullCalendar('option', 'locale', localeCode);
}

function getEventWindowHeight() {
  // NOTE: Both versions are correct. The second version avoids guesswork about the view parameters

  //var eventWindowHeightRegion = $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller');
  //return eventWindowHeightRegion.height()

  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  //return (view.el.height());
  return (view.spreadsheet.tbodyEl.height());
}

function getEventWindowWidth() {
  // NOTE: Both versions are correct. The second version avoids guesswork about the view parameters but, does not work

  // The following line was commented out on the 11.11.2018
  //var eventWindowWidthRegion = $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller-canvas');

  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  // Fudge factor to be applied, due to extra table separators

  // The following line was commented out on the 11.11.2018
  //var fudgeFactor = (view.slotDuration.asHours() < 1)  ? 1.015 : 1;

  // new line added on the 11.11.2018
  return view.timeBodyScroller.canvas.width;

  // The following line was commented out on the 11.11.2018
  //return (eventWindowWidthRegion.width() / fudgeFactor);


  //var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  //return (view.slotCnt * view.slotWidth);
}

function getEventWindowHours() {
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  var start = view.intervalStart;
  var end = view.intervalEnd;
  var days = end.diff(start, "days");
  var eventWindowHours = 24 * days;
  return eventWindowHours;
}

function renderScrollBar() {
  $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller').doubleScroll({
    onlyIfScroll: true, // top scrollbar is not shown if the bottom one is not present
    resetOnWindowResize: true // recompute the top ScrollBar requirements when the window is resized
  });
}

function updateTimelineDuration() {
  var start_date = $.trim($("#start_date").val());
  var end_date = $.trim($("#end_date").val());

  if( end_date.length ) {
    //$('#fullcalendar_scheduler').fullCalendar('changeView', 'timeline', {
    //  start: start_date,
    //  end: end_date
    //});
    //$('#fullcalendar_scheduler').fullCalendar('render');
  } else {
    $('#fullcalendar_scheduler').fullCalendar( 'gotoDate', start_date );
  }
}

function repeatUntilDateTimeBuilder() {
  $("#resource_planner_event_until_count").val("");
  document.getElementById("resource_planner_event_until_repeat_until").checked = true;
  //var b = $("#resource_planner_event_until_1i :selected").text();
  var year = $.trim($("#resource_planner_event_until_1i").val());
  var month = $.trim($("#resource_planner_event_until_2i").val());
  var day = $.trim($("#resource_planner_event_until_3i").val());
  var hour = $.trim($("#resource_planner_event_until_time_4i").val());
  var minute = $.trim($("#resource_planner_event_until_time_5i").val());


  if (year !== "" && month !== "") {                  // Year and Month must be selected
    month = (day !== "")  ? (month - 1) : month;      // when day !== "", reduce month by 1. Somehow it is strange
    var yearMonthDay = new Date(year, month, day, hour, minute);
    var untilDate = moment(yearMonthDay).format();
    console.log("untilDate: " + untilDate);
    reccurences('untilDate');
  }
}