function reccurences(occurrenceType, howOften) {

  console.log("highlighted_bar_1");

  if( getHighlighterBar().length == 0 ) {
    $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller div.fc-scroller-canvas').prepend($('<div id="highlighter" draggable="true"></div>'));
  }


  switch( occurrenceType ) {
    case 'daily':
      var start_date = $.trim($("#start_date").val());
      var duration = $.trim($("#duration").val());
      var durationUnits = $.trim($("#hourSelect").val());

  
      var isRTL = $('#fullcalendar_scheduler').fullCalendar('option', 'isRTL');
      var view = $('#fullcalendar_scheduler').fullCalendar('getView');
        if( duration.length ) {
         var width = setHighlighterBarWidth(duration, durationUnits)

         if( isRTL ) {
            getHighlighterBar().css('left', getEventWindowWidth() - ((((startDate.getTime() + tzOffset()) - viewStartTime) /viewDuration)  * getEventWindowWidth()) - width );
          } else {
          getHighlighterBar().css('left', (((startDate.getTime() + tzOffset()) - viewStartTime)/viewDuration) * view.timeBodyScroller.canvas.width);
         }
        }
      break;

      case 'date':
      default:
        if(end_date.length) {
          if( isRTL ) {
            getHighlighterBar().css('left',  (view.timeBodyScroller.canvas.width - ((((endDate.getTime() - viewStartDate.getTime()) + tzOffset())  /viewDuration) * view.timeBodyScroller.canvas.width)));              
          } else {
            getHighlighterBar().css('left', (((startDate.getTime() + tzOffset()) - viewStartTime)/viewDuration) * view.timeBodyScroller.canvas.width);
          }
          setHighlighterBarWidth( moment(endDate).diff(moment(startDate), durationUnits), durationUnits);
        }
        break;
    }
  
}

console.log("highlighted_bar_2");

function getHighlighterBar() {
  return $('#highlighter');
}

function tzOffset() {                                                 // Calculates the UTC Offsets
  var startTZ = $("#resource_planner_event_dtstart_timezone").val();  // Read the timezone selected
  var startZone = moment;            
  startZone.tz.setDefault(startTZ)();                                 // Set the Timezone
  var utcOffset = startZone().utcOffset() * 60000;                    // Total UTC offset in milliseconds

  return utcOffset;
}

function getEventDurationHours() {
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');

  var viewDuration = view.intervalEnd.diff(view.intervalStart, "hours");
  var eventDurationHours = viewDuration * getHighlighterBar().width() / getEventWindowWidth();

  //// Every slot with an intermediate marker has one extra pixel, in width
  //var slotWidth = (view.slotDuration.asHours() < 1)  ? (view.slotWidth-0.5) : view.slotWidth;
  //var eventDurationHours = view.slotDuration.asHours() * getHighlighterBar().width()/slotWidth;

  return eventDurationHours;
}

function setHighlighterBarWidth(duration, durationUnits) {
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');

  var eventDurationHours;
  switch( durationUnits ) {
    case 'day':
      eventDurationHours = duration * 24.0;
      break;
    case 'hour':
      eventDurationHours = duration;
      break;
    case 'minute':
      eventDurationHours = duration / 60.0;
      break;
    default:
      eventDurationHours = duration / 60.0;
  }

  var viewDuration = view.intervalEnd.diff(view.intervalStart, "hours");
  var width = getEventWindowWidth() * eventDurationHours / viewDuration;

  //// Every slot with an intermediate marker has one extra pixel, in width
  //var slotWidth = (view.slotDuration.asHours() < 1)  ? (view.slotWidth-0.5) : view.slotWidth;
  //var width = (eventDurationHours * slotWidth) / view.slotDuration.asHours();

  getHighlighterBar().css('width', width );

  return width;
}

function renderDurationField() {
  var eventDurationHours = getEventDurationHours();
  var durationUnits = $.trim($("#hourSelect").val());

  var duration;
  switch( durationUnits ) {
    case 'day':
      duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
      duration = Math.round(eventDurationHours * 60);
      break;
    default:
      duration = Math.round(eventDurationHours * 60);
  }

  $("#duration").val(duration);
  $("#resource_planner_event_duration").val(duration);
}

function renderEndDateField() {
  var startDate = new Date( $.trim($("#start_date").val()) );
  var duration = $.trim($("#duration").val());
  var durationUnits = $.trim($("#hourSelect").val());

  var endDate = dateAdd(startDate, durationUnits, duration);

  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  
  if (isNaN(endDate) && isNaN(startDate)) {
    endDate = "";
    startDate = "";
    duration = "";
    $("#duration").val(duration);
  } else {
      $("#end_date").val( formatDate(endDate) );
      $("#duration").val(duration);
  }
}

function onHighlighterBarUpdate(event, ui, obj) {     //Function is triggered by either DRAG or RESIZE events
  console.log("highlighted_bar_3");
  var isRTL = $('#fullcalendar_scheduler').fullCalendar('option', 'isRTL');
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  var viewStartDate = new Date(view.intervalStart.toDate());
  var viewEndDate = new Date(view.intervalEnd.toDate());

  var viewStartTime = viewStartDate.getTime();
  var viewEndTime = viewEndDate.getTime();
  var viewDuration = viewEndTime - viewStartTime;

  var eventStartTimeHours;
  var eventEndTimeHours;
  var eventDurationHours = getEventDurationHours();

  if( isRTL ) {
    eventEndTimeHours   = getEventWindowHours() - (getEventWindowHours() * ui.position.left / getEventWindowWidth());
    eventStartTimeHours = eventEndTimeHours - eventDurationHours;
  } else {
    eventStartTimeHours = getEventWindowHours() * ui.position.left / getEventWindowWidth();
    eventEndTimeHours   = eventStartTimeHours + eventDurationHours;
  }

  // Date object methods
  // setDate()	Sets the day of the month of a date object
  // setFullYear()	Sets the year of a date object
  // setHours()	Sets the hour of a date object
  // setMilliseconds()	Sets the milliseconds of a date object
  // setMinutes()	Set the minutes of a date object
  // setMonth()	Sets the month of a date object

  // renderStartDateField()
  var startDate = dateAdd(viewStartDate, 'day', parseInt(eventStartTimeHours/24));
  startDate.setHours( Math.floor(eventStartTimeHours % 24) );
  startDate.setMinutes( 60 * (eventStartTimeHours % 1).toFixed(10) );
  $("#start_date").val( formatDate(startDate) );

  renderDurationField();

  renderEndDateField();
}

function renderHighlighterBar(trigger) {  //function triggered when '.date-field' or '#duration' fields changed
console.log("highlighted_bar_4");

  if( getHighlighterBar().length == 0 ) {
    $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller div.fc-scroller-canvas').prepend($('<div id="highlighter" draggable="true"></div>'));
  }

  tzOffset();
  //tzOffset();

  getHighlighterBar().on('drag', function( event, ui ) {
    onHighlighterBarUpdate(event, ui, $(this));
  });

  getHighlighterBar().on('resize', function( event, ui ) {
    onHighlighterBarUpdate(event, ui, $(this));
  });

  var start_date = $.trim($("#start_date").val());
  var end_date = $.trim($("#end_date").val());
  var duration = $.trim($("#duration").val());
  var durationUnits = $.trim($("#hourSelect").val());

  var isRTL = $('#fullcalendar_scheduler').fullCalendar('option', 'isRTL');
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');

  var viewStartDate = new Date(view.intervalStart.toDate());
  var viewEndDate = new Date(view.intervalEnd.toDate());

  var viewStartTime = viewStartDate.getTime();
  var viewEndTime = viewEndDate.getTime();
  var viewDuration = viewEndTime - viewStartTime;

  getHighlighterBar().height( getEventWindowHeight() );
  getHighlighterBar().draggable({ axis: "x" });
  getHighlighterBar().resizable({ handles: "e, w" });

  //console.log("start_date: " + start_date);
  if( (start_date.length && end_date.length) || (duration.length) || (start_date == "") ) {
    var startDate = new Date(start_date);
    var endDate = new Date(end_date);

    
    // End Date must be >= start Date
    if ((endDate.getTime() <= startDate.getTime()) || isNaN(endDate) || isNaN(startDate)) {      
       end_date = $("#start_date").val();
       endDate = new Date(end_date);
       $("#end_date").val( end_date );
       duration = "";
       $("#duration").val(duration);
       var width = 0;
       getHighlighterBar().css('width', width )
    }

    switch( trigger ) {
      case 'duration':
        if( duration.length ) {
          var width = setHighlighterBarWidth(duration, durationUnits)

          if( isRTL ) {
            getHighlighterBar().css('left', getEventWindowWidth() - ((((startDate.getTime() + tzOffset()) - viewStartTime) /viewDuration)  * getEventWindowWidth()) - width );
          } else {
            getHighlighterBar().css('left', (((startDate.getTime() + tzOffset()) - viewStartTime)/viewDuration) * view.timeBodyScroller.canvas.width);
          }
        }
        break;

        case 'date':
        default:
          if(end_date.length) {
            if( isRTL ) {
              getHighlighterBar().css('left',  (view.timeBodyScroller.canvas.width - ((((endDate.getTime() - viewStartDate.getTime()) + tzOffset())  /viewDuration) * view.timeBodyScroller.canvas.width)));              
            } else {
              getHighlighterBar().css('left', (((startDate.getTime() + tzOffset()) - viewStartTime)/viewDuration) * view.timeBodyScroller.canvas.width);
            }
            setHighlighterBarWidth( moment(endDate).diff(moment(startDate), durationUnits), durationUnits);
          }
          break;
      }
    getHighlighterBar().css('visibility', 'visible'); // TODO: Move this inside the if block
    
    if ((getHighlighterBar()[0].clientWidth > 0 && (endDate.getTime() > startDate.getTime())) || (getHighlighterBar()[0].clientWidth > 0 && isNaN(endDate.getTime()) ) ) {
      renderDurationField();
    }
  }
}
